package de.tudresden.inf.st.ros2rag.senderstub;

import de.tudresden.inf.st.ros2rag.starter.ast.MqttHandler;
import panda.Linkstate;

import java.util.concurrent.TimeUnit;

public class Main {
  public static void main(String[] args) throws Exception {
    // assume 4 arguments
    if (args.length < 4) {
      System.err.println("Sends a new position, expected arguments: topic x y z");
      return;
    }
    final String topic = args[0];
    Linkstate.PandaLinkState pls = Linkstate.PandaLinkState.newBuilder()
        .setName(args[0])
        .setPos(Linkstate.PandaLinkState.Position.newBuilder()
            .setPositionX(Float.parseFloat(args[1]))
            .setPositionY(Float.parseFloat(args[2]))
            .setPositionZ(Float.parseFloat(args[3]))
            .build())
        .build();
    final byte[] message = pls.toByteArray();

    MqttHandler sender = new MqttHandler("sender stub").dontSendWelcomeMessage();
    sender.setHost("localhost", 1883);
    sender.waitUntilReady(2, TimeUnit.SECONDS);
    sender.publish(topic, message);
    sender.close();
  }
}
